part of 'core.dart';

class DataResponse<T> extends Response<T> {
  DataResponse({
    super.requestCode,
    super.available,
    super.cancel,
    super.complete,
    super.error,
    super.failed,
    super.internetError,
    super.loading,
    super.nullable,
    super.paused,
    super.stopped,
    super.successful,
    super.timeout,
    super.valid,
    super.data,
    super.backups,
    super.ignores,
    super.result,
    super.progress,
    super.status,
    super.exception,
    super.message,
    super.feedback,
    super.snapshot,
  });

  @override
  DataResponse<T> copy({
    int? requestCode,
    bool? available,
    bool? cancel,
    bool? complete,
    bool? error,
    bool? failed,
    bool? internetError,
    bool? loading,
    bool? nullable,
    bool? paused,
    bool? stopped,
    bool? successful,
    bool? timeout,
    bool? valid,
    T? data,
    List<T>? backups,
    List<T>? ignores,
    List<T>? result,
    double? progress,
    Status? status,
    String? exception,
    String? message,
    dynamic feedback,
    dynamic snapshot,
  }) {
    return DataResponse<T>(
      available: available,
      cancel: cancel,
      complete: complete,
      data: data,
      error: error,
      exception: exception,
      failed: failed,
      feedback: feedback,
      internetError: internetError,
      loading: loading ?? false,
      message: message,
      nullable: nullable,
      paused: paused,
      progress: progress ?? this.progress,
      requestCode: requestCode ?? this.requestCode,
      backups: backups,
      ignores: ignores,
      result: result,
      snapshot: snapshot,
      status: status,
      stopped: stopped,
      successful: successful,
      timeout: timeout,
      valid: valid,
    );
  }

  @override
  DataResponse<T> from(Response<T> response) {
    return copy(
      available: response.isAvailable,
      cancel: response.isCancel,
      complete: response.isComplete,
      data: response.data,
      error: response.isError,
      exception: response.exception,
      failed: response.isFailed,
      feedback: response.feedback,
      internetError: response.isInternetError,
      loading: response.isLoading,
      message: response.message,
      nullable: response.isNullable,
      paused: response.isPaused,
      progress: response.progress,
      requestCode: response.requestCode,
      backups: response.backups,
      ignores: response.ignores,
      result: response.result,
      snapshot: response.snapshot,
      status: response.status,
      stopped: response.isStopped,
      successful: response.isSuccessful,
      timeout: response.isTimeout,
      valid: response.isValid,
    );
  }
}
